/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Server;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import Client.IClientInterface;
import java.util.LinkedList;

public class ServerImpl extends UnicastRemoteObject implements IServerInterface{

    private final LinkedList<IClientInterface> clients;

    private boolean isDelay = false;
    private long delayTime = 5000;

    public void setIsDelya(boolean isDelay){
        this.isDelay = isDelay;
    }

    public void setDelayTime(long delayTime){
        this.delayTime = delayTime;
    }

    public ServerImpl() throws RemoteException {
        clients = new LinkedList<IClientInterface>();
    }

    public static ServerImpl createServer(){
        try {
            Registry rmi = LocateRegistry.createRegistry(IServerInterface.PORT);
            ServerImpl server = new ServerImpl();
            rmi.bind(IServerInterface.LOOKUP_NAME, server);
            return server;
        } catch (Exception ex) {
            //Error handling
            return null;
        }
    }

    public void register(IClientInterface client) throws RemoteException{
        synchronized(clients){
            clients.add(client);
        }
    }

    public void sendMessage(IClientInterface inClient, String str) throws RemoteException{
        synchronized(clients){

            if (isDelay){
                try
                {
                    Thread.sleep(delayTime);
                }catch (InterruptedException ie)
                {
                    //Error handling
                }
            }

            for(IClientInterface client : clients){                
                if (!client.equals(inClient)){
                    try{
                     client.receiveMessage(str);
                    }
                    catch(RemoteException ex){
                        //Error handling
                    }
                }
            }
        }
    }
}
