package Server;

import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import Shared.IDownloadSession;
import Shared.DownloadBlock;

public class DownloadSession extends UnicastRemoteObject implements IDownloadSession {
	private static final long serialVersionUID = 1L;

	private DownloadManager manager;
	private DownloadSource source;
	private long checkSum;
	
	public DownloadSession(DownloadManager manager,DownloadSource source,long checkSum) throws RemoteException {
		super();
		this.manager = manager;
		this.source = source;
		this.checkSum = checkSum;
	}
	
	public void finishedDownload() throws RemoteException {
		manager.finished();
	}

	public DownloadBlock getCurrentBlock() throws RemoteException, IOException {
		return source.getCurrentBlock();
	}

	public void nextBlock() throws RemoteException {
		source.nextBlock();
	}

	@Override
	public long getCheckSum() throws RemoteException {
		return checkSum;
	}
}
