/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SlideShow.java
 *
 * Created on 17.03.2009, 17:00:36
 */

/**
 *
 * @author rudicha
 */

import javax.swing.ImageIcon;
import java.io.File;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class SlideShow extends javax.swing.JFrame implements ActionListener{

    private int imageNumber = 7;
    private int currentImage = imageNumber;
    private ImageIcon[] images;
    private boolean isPlaying = false;
    private Timer timer;

    /** Creates new form SlideShow */
    public SlideShow() {
        initComponents();
        loadImages();
        startTimer();
    }

    private void loadImages(){
        images = new ImageIcon[imageNumber];
        String str = "." + File.separator + "Images" +
                    File.separator + "chakra-" + 2 + ".png";
        for(int i = 1; i <= imageNumber; i++)
            images[i-1] = new ImageIcon("." + File.separator + "Images" +
                    File.separator + "chakra-" + i + ".png");
    }

    private void startTimer(){
        timer = new Timer(speed.getValue()*10, this);
        timer.start();
    }

    public void actionPerformed(ActionEvent e) {
        if (isPlaying){
            currentImage = (currentImage + 1) % imageNumber;
            outImage.setIcon(images[currentImage]);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSlider1 = new javax.swing.JSlider();
        outImage = new javax.swing.JLabel();
        play = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        speed = new javax.swing.JSlider();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Slideshow");

        play.setText("Play");
        play.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playActionPerformed(evt);
            }
        });

        jLabel2.setText("Speed");

        speed.setMinimum(1);
        speed.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                speedStateChanged(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(play, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel2)
                        .addGap(18, 18, 18)
                        .addComponent(speed, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(36, 36, 36)
                        .addComponent(outImage, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(outImage, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(play)
                        .addComponent(jLabel2))
                    .addComponent(speed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void playActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playActionPerformed
        if(isPlaying){
            play.setText("Play");
            isPlaying = false;
        } else {
            play.setText("Pause");
            isPlaying = true;
        }
    }//GEN-LAST:event_playActionPerformed

    private void speedStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_speedStateChanged
        timer.setDelay(speed.getValue()*10);
    }//GEN-LAST:event_speedStateChanged

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SlideShow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel2;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JLabel outImage;
    private javax.swing.JButton play;
    private javax.swing.JSlider speed;
    // End of variables declaration//GEN-END:variables

}
