import java.awt.TextArea;

public class FormattedTextArea extends TextArea {
    
    private Paragraph para;  // paragraph that contains the formated text
    private Counter c; // counter 
    private int last_alignment;
    
    /** Creates a new instance of FormattedTextArea */
    public FormattedTextArea() {
        c = new Counter();
        para = new Paragraph (20,c);
        last_alignment=1; // setting default alignment
    }
    
   /** get the text paragraph. it makes the concatenation of every line and returns an string  */
    public String getText() {
       return doAlignment(last_alignment);
    }
    
    /**
     * it sets the FormattedTextArea
     * @param t the source text
     */
   public void append(String str) {
       para.addLine(str);
       super.setText(doAlignment(last_alignment));
   }
   
    /**
     * a test for the align algorithm
     * @param i the algorithm to use
     */
   public String doAlignment(int i) {
       last_alignment = i;
       Formatter a;
       if (i==0)
           a = new AlignRight();
       else if(i==1)
           a = new AlignLeft();
       else
           a = new AlignCenter();

       String [] arr = para.align(a);
       String result="";
       for(int j=0; j < arr.length; j++) {
           if(arr[j] == null)
               break;
           result += arr[j] + "\n";
       }
       return result;
   }
   
   public int lenght() {
       return c.getCounter(); 
   }
}
